#include "gfx.h"

// window
#define WINDOW_X    0
#define WINDOW_Y    120
#define WINDOW_W    320
#define WINDOW_H    240

#define COLOUR_BG   HTML2COLOR(0x202020)
#define COLOUR_1    GFX_BLUE
#define COLOUR_2    GFX_RED
#define COLOUR_3    GFX_FUCHSIA

#define MIN_U       0
#define MIN_I       0
#define MAX_U       15000
#define MAX_I       5000

static gCoord pos_X;

// from Arduino
static long map(long x, long in_min, long in_max, long out_min, long out_max) {
      return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

void graph_Init(void) {
    // clear area
    gdispFillArea(WINDOW_X, WINDOW_Y, WINDOW_W, (WINDOW_H-WINDOW_Y), COLOUR_BG);

    pos_X = 0;
}

void graph_Draw(uint32_t u_value, uint32_t i_value) {
    gCoord u = map(u_value, MIN_U, MAX_U, WINDOW_H-1, WINDOW_Y);
    gCoord i = map(i_value, MIN_I, MAX_I, WINDOW_H-1, WINDOW_Y);

    // cleear col
    gdispDrawLine(pos_X, WINDOW_H, pos_X, WINDOW_Y, COLOUR_BG);

    // draw new values
    if (u == i) {
        gdispDrawLine(pos_X, WINDOW_H-1, pos_X, i, COLOUR_3);
    } else if (u < i) {
        gdispDrawLine(pos_X, WINDOW_H-1, pos_X, i, COLOUR_2);
        gdispDrawLine(pos_X, i+1, pos_X, u, COLOUR_1);
    } else {
        gdispDrawLine(pos_X, WINDOW_H-1, pos_X, u, COLOUR_1);
        gdispDrawLine(pos_X, u+1, pos_X, i, COLOUR_2);
    }

    pos_X ++;
    if (pos_X >= WINDOW_W) {
        pos_X = 0;
    }

    gdispDrawLine(pos_X, WINDOW_H, pos_X, WINDOW_Y, GFX_GREEN);
}
